Loading...
Searching...
No Matches
BALL::QSAR::BayesModel Class Referenceabstract

`#include <BALL/QSAR/bayesModel.h>`

Inheritance diagram for BALL::QSAR::BayesModel:

## Public Member Functions

| BayesModel (const QSARData &q)
virtual bool | isTrained ()=0
virtual vector< double > | calculateProbabilities (int activitiy_index, int feature_index, double feature_value)=0
virtual int | getNoResponseVariables ()=0
Public Member Functions inherited from BALL::QSAR::ClassificationModel
| ClassificationModel (const QSARData &q)
| ~ClassificationModel ()
virtual void | operator= (ClassificationModel &m)
std::vector< int > | getClassLabels ()
Public Member Functions inherited from BALL::QSAR::Model
| Model (const QSARData &q)
virtual | ~Model ()
virtual void | operator= (const Model &m)
void | copyData (const Model &m)
void | copyDescriptorIDs (const Model &m)
void | readTrainingData ()
virtual Eigen::VectorXd | predict (const vector< double > &substance, bool transform)=0
void | deleteDescriptorIDs ()
virtual void | train ()=0
virtual bool | optimizeParameters (int, int)
bool | optimizeParameters (int k)
virtual double | calculateStdErr ()
virtual void | setParameters (vector< double > &)
virtual vector< double > | getParameters () const
std::multiset< unsigned int > * | getDescriptorIDs ()
void | setDataSource (const QSARData *q)
virtual void | saveToFile (string filename)=0
virtual void | readFromFile (string filename)=0
const Eigen::MatrixXd * | getDescriptorMatrix ()
const vector< string > * | getSubstanceNames ()
const vector< string > * | getDescriptorNames ()
const Eigen::MatrixXd | getDescriptorTransformations ()
const Eigen::MatrixXd | getYTransformations ()
const Eigen::MatrixXd * | getY ()
void | setDescriptorIDs (const std::multiset< unsigned int > &sl)
const string * | getType ()
void | getUnnormalizedFeatureValue (int compound, int feature, double &return_value)
void | getUnnormalizedResponseValue (int compound, int response, double &return_value)

## Protected Attributes

double | min_prob_diff_
double | undef_act_class_id_
std::vector< int > | labels_
std::vector< int > | no_substances_
void(ClassificationModel::* | discretizeFeatures )(unsigned int bins, Eigen::MatrixXd &discretization_information)
void(ClassificationModel::* | discretizeTestDataFeatures )(Eigen::VectorXd &compound, unsigned int bins, const Eigen::MatrixXd &discretization_information)
int | default_no_opt_steps_
Eigen::MatrixXd | descriptor_matrix_
vector< string > | substance_names_
vector< string > | descriptor_names_
Eigen::MatrixXd | descriptor_transformations_
Eigen::MatrixXd | y_transformations_
Eigen::MatrixXd | Y_
String | type_
std::multiset< unsigned int > | descriptor_IDs_

## Additional Inherited Members

ClassificationValidation * | validation
const QSARData * | data
Validation * | model_val
Protected Member Functions inherited from BALL::QSAR::ClassificationModel
void | readClassInformationFromFile (std::ifstream &input, int no_classes)
void | saveClassInformationToFile (std::ofstream &out)
void | readLabels ()
void | equalSpaceDiscretization (unsigned int bins, Eigen::MatrixXd &discretization_information)
void | equalSpaceDiscretizationTestData (Eigen::VectorXd &compound, unsigned int bins, const Eigen::MatrixXd &discretization_information)
Protected Member Functions inherited from BALL::QSAR::Model
void | readMatrix (Eigen::MatrixXd &mat, std::ifstream &in, unsigned int lines, unsigned int col)
void | readVector (Eigen::RowVectorXd &vec, std::ifstream &in, unsigned int no_cells, bool column_vector)
void | readModelParametersFromFile (std::ifstream &in)
void | saveModelParametersToFile (std::ofstream &out)
virtual void | saveDescriptorInformationToFile (std::ofstream &out)
virtual void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation)
void | readResponseTransformationFromFile (std::ifstream &in, int no_y)
void | saveResponseTransformationToFile (std::ofstream &out)
Eigen::VectorXd | getSubstanceVector (const vector< double > &substance, bool transform)
Eigen::VectorXd | getSubstanceVector (const Eigen::VectorXd &substance, bool transform)
void | backTransformPrediction (Eigen::VectorXd &pred)
void | addLambda (Eigen::MatrixXd &matrix, double &lambda)
void | readDescriptorInformation ()

## Detailed Description

interface class for all Bayes classification models

Definition at line 18 of file bayesModel.h.

## Constructor & Destructor Documentation

## BayesModel()

BALL::QSAR::BayesModel::BayesModel | ( | const QSARData & | q | ) |

## Member Function Documentation

## calculateProbabilities()

virtual vector< double > BALL::QSAR::BayesModel::calculateProbabilities | ( | int | activitiy_index,
|  | int | feature_index,
|  | double | feature_value )

pure virtual

calculate the probability for the specified feature to assume the given value for each class

Returns
  a probability for each class

Implemented in BALL::QSAR::NBModel, and BALL::QSAR::SNBModel.

## getNoResponseVariables()

virtual int BALL::QSAR::BayesModel::getNoResponseVariables | ( |  | ) |

pure virtual

returns the number of response variables for which this model has been trained

Implemented in BALL::QSAR::NBModel, and BALL::QSAR::SNBModel.

## isTrained()

virtual bool BALL::QSAR::BayesModel::isTrained | ( |  | ) |

pure virtual

Implemented in BALL::QSAR::NBModel, and BALL::QSAR::SNBModel.

## Member Data Documentation

## min_prob_diff_

double BALL::QSAR::BayesModel::min_prob_diff_

protected

the minimal desired difference between the predicted class and the second best class. If the difference is smaller than this value, undef_act_class_id_ should be used instead.

Definition at line 36 of file bayesModel.h.

## undef_act_class_id_

double BALL::QSAR::BayesModel::undef_act_class_id_

protected

the class_id that is to be assigned, if no class could be savely predicted, if difference between best and second best potential class is smaller than min_prob_diff_

Definition at line 39 of file bayesModel.h.